#ifndef _MIDI_INTERFACE_H_
#define _MIDI_INTERFACE_H_

/** WIMIDĨC^tF[X */
class MIDIDeviceI
{
public:
  /**
   * m[gON velocity0̎͏
   * MIDIbZ[W $9x, $note, $velocity
   */
  virtual void NoteOn(int ch, int note, int velocity)=0;
  /**
   * m[gOFF velocity͉鑬
   * MIDIbZ[W $8x, $note, $velocity
   */
  virtual void NoteOff(int ch, int note, int velocity)=0;
  
  /**
   * |tHjbNL[vbV
   * MIDIbZ[W $Ax, $pressure
   */
  virtual void PolyKeyPressure(int ch, int note, int pressure)=0;

  /**
   * `lvbV
   * MIDIbZ[W $Dx, $pressure
   */
  virtual void ChannelPressure(int ch, int pressure)=0;

  /**
   * sb`xh
   * MIDIbZ[W $Ex, $data
   */
  virtual void PitchBendChange(int ch, int data)=0;
  
  /**
   * Rg[`FW
   * MIDIbZ[W $Bx, $ctrl_no, $data
   */
  virtual void ControlChange(int ch, int ctrl_no, int data)=0;

  /**
   * vO`FW
   * MIDIbZ[W $Cx, $prg_no
   */
  virtual void ProgramChange(int ch, int prg_no)=0;

  /**
   * [hbZ[W
   * MIDIbZ[W $Bn, $mode, $data   $mode  $78`$7f
   */
  virtual void ModeMessage(int ch, int mode, int data)=0;

  /**
   * GNXN[VubZ[W
   * MIDI bZ[W $F0, $id, $data, ... $F7
   */
  virtual void ExclusiveMessage(int id, int *data, int size)=0;
};




#endif