#ifndef _PLAYER_H_
#define _PLAYER_H_
#include <set>
#include "../xtypes.h"
#include "../debugout.h"
#include "../../vcm/vcm.h"
#include "soundData.h"
#include "../devices/device.h"

namespace xgm {

  /**
   * n̐ݒǗNX
   * @see Player
   */
  class PlayerConfig : public vcm::Configuration
  {
  };

  /**
   * n
   */
  class Player : public vcm::ObserverI
  {
  protected:
    PlayerConfig *config;

  public:
    /**
     * GetLoopCount\bh̓ʂȖ߂l
     * @see GetLoopCount
     */
    enum { NEVER_LOOP=-1, INFINITE_LOOP=0 };

    Player()
    {
        config = NULL;
    }

    virtual ~Player(){ 
        if(config != NULL)
            config->DetachObserver(this);
    }

    /**
     * PlayerConfigIuWFNgA^b`
     * <P>
     * PlayerConfigIuWFNg̃IuU[oɁC̃IuWFNgIɓo^D
     * </P>
     * @param pc A^b`PlayerConfigIuWFNg
     */
    virtual void SetConfig(PlayerConfig *pc)
    { 
      config = pc;
      config->AttachObserver(this);
    }
    
    virtual PlayerConfig *GetConfig()
    {
      return config;
    }

    /**
     * PlayerConfigIuWFNgXVꂽɃR[Gg
     * @param param XVXe[^X
     */
    virtual void Notify(int param){};

    /**
     * tf[^[h
     * <P>
     * PlayerIuWFNǵAɉtf[^̃Rs[i[ȂB
     * āAPlayerIuWFNg̉tɉtf[^łĂ͂ȂB
     * tf[^̐ƏłPlayerIuWFNg̊OŊǗB
     * </P>
     * @param data tf[^ւ̃|C^
     * @return  ture s false
     */
    virtual bool Load(SoundData *sdat)=0;

    /**
     * vC
     */
    virtual void Reset()=0;

    /**
     * Đ[gݒ肷
     */
    virtual void SetPlayFreq(double rate)=0;

    /**
     * Number of channels to output.
     */
    virtual void SetChannels(int channels)=0;

    /**
     * f[^̃_Os
     * <P>
     * obt@TCY samples * sizeof(INT16)Kv
     * </P>
     * @param buf _Of[^i[obt@
     * @param samples Tv̌
     *                0^ĂnOAbvĂ͂ȂȂ
     * @return ۂɐꂽTv
     */
    virtual UINT32 Render(INT16 *buf, UINT32 samples)=0;

    /** tF[hAEg */
    virtual void FadeOut(int fade_in_ms)=0;

    /**
     * f[^̃_OXLbv
     * @param samples XLbvTv
     *                0^ĂnOAbvĂ͂ȂȂD
     * @return ۂɃXLbvTv
     */
    virtual UINT32 Skip(UINT32 samples)=0;

    /**
     * t~ǂ𒲂ׂD
     * @return ~ȂtrueDtȂfalseD
     */
    virtual bool IsStopped()=0;

    /**
     * t[v񐔂`FbND
     * <P>
     * ̉t1[vڂƐD
     * </P>
     * @return t[v񐔁D
     NEVER_LOOP̏ꍇ̓[vȂf[^CINFINITE_LOOP̏ꍇ͖[vf[^łD
     */
    virtual int  GetLoopCount(){ return NEVER_LOOP; }
    virtual const char* GetTitleString(){ return "UNKNOWN"; }
    virtual int GetLength(){ return 5*60*1000; }
    
    /* ԍid̎timeł̃foCX擾 time==-1݂̎͌̃foCXԂ */
    virtual IDeviceInfo *GetInfo(int time_in_ms, int device_id){ return NULL; }
  };

  class PlayerMSP : public Player
  {
  public:
    PlayerMSP() : Player(){};
    virtual ~PlayerMSP(){};
    /**
     * ̋Ȃɐi
     * @param step i߂Ȑ
     * @return  true s false
     */
    virtual bool NextSong(int s){ return false; }

    /**
     * ŐȂɖ߂
     * @param step ߂Ȑ
     * @return  true s false
     */
    virtual bool PrevSong(int s){ return false; }

    /**
     * Ȕԍ𒼐ڐݒ肷
     * @param song Ȕԍ
     * @return  true s false
     */
    virtual bool SetSong(int song){ return false; }

    /**
     * ݑI𒆂̋Ȕԍl
     * @return Ȕԍ
     */
    virtual int GetSong(){ return -1; }
  };

}// xgm
#endif
